using System;
using System.Security.Principal;
using System.Reflection;

namespace RolesCS
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			ShowUserInfo();
			ShowUserRoles();
			Console.ReadLine();
		}

		public static void ShowUserInfo()
		{
			WindowsPrincipal ARole =  new WindowsPrincipal(WindowsIdentity.GetCurrent());
			Console.WriteLine(ARole.Identity.Name + "...");
			if (ARole.IsInRole("BUILTIN\\Administrators")) 
			{
				Console.WriteLine("is an administrator");
			}
			if (ARole.IsInRole("BUILTIN\\Users") )
			{
				Console.WriteLine("is a user ");
			}
		}
	
		public static void ShowUserRoles()
		{
			String[] roles;
			WindowsIdentity CurrentIdentity = WindowsIdentity.GetCurrent();
			Object roleobject;
			try 
			{
				roleobject = typeof(WindowsIdentity).InvokeMember("GetRoles", BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.NonPublic, null, CurrentIdentity, null);
			}
			catch 
			{
				Console.WriteLine("Error occurred accessing the GetRoles method - is your application configuration file correct?");
				return;
			}
			roles = (String[])roleobject;

			Console.WriteLine("User " + CurrentIdentity.Name + " belongs to:");
			foreach(String role in roles) 
			{
				Console.WriteLine(role);
			}
		}
	}
}
